import rospy
import actionlib
from typing import Optional

{% for sk in skills %}
from {{ skillset }}_managers.msg import {{ sk.name|action_name }}Action, {{ sk.name|action_name }}Goal
{% endfor %}

from .logic import *
from .resourceset_interface import ResourceSet

{% for s in skills %}
class {{ s.name|action_name }}Interface:
    def __init__(self, **kwargs):
        self.__name = '{{ s.name }}'
        # formula for preconditions
        self.__formula_pre = dict()
        {% for pre in s.preconditions|selectattr('resource') %}
        self.__formula_pre['{{ pre.name }}'] = {{ pre.resource|expression }}
        {% endfor %}
        self.__progress = None

        self.__client = actionlib.SimpleActionClient("skill/{}".format('{{ s.name }}'), 
                                    {{ s.name|action_name }}Action)
        self.__action_spec = {{ s.name|action_name }}Action
        self.__goal_spec = {{ s.name|action_name }}Goal
        self.__state = None
        self.__running = False

    @property
    def name(self):
        """Skill name"""
        return self.__name

    ## Server connections
    @property
    def ready(self):
        return self.__client.ready()

    def __nonzero__(self):
        return self.ready()

    def __bool__(self):
        return self.ready()

    def wait_manager(self, timeout: Optional[float] = 0.0) -> bool:
        """Wait until the action server has started listening for goals"""
        return self.__client.wait_for_server(timeout=rospy.Duration.from_sec(timeout))

    ## Progress
    def __feedback_cb(self, feedback):
        rospy.logdebug(f"received feedback {feedback}")
        self.__progress = feedback.progress

    @property
    def progress(self) -> float:
        """Progress value"""
        return self.__progress

    ## Preconditions
    def check_resource_precondition(self, resources: ResourceSet):
        for label, formula in self.__formula_pre.items():
            states = dict()
            for resource in formula.symbols():
                states[resource] = resources[resource].get()
            if not formula.eval(states):
                return False
        return True


    ## Start
    def start(self, *args, **kwargs):
        """Start the skill execution.
        """
        self.__progress = None
        self.__client.send_goal(self.__goal_spec(*args, **kwargs),
                                done_cb = self.__done_cb,
                                active_cb = self.__active_cb,
                                feedback_cb = self.__feedback_cb)
        return True

    def __done_cb(self, state, result):
        self.__running = False
        self.__state = result.state
        rospy.logdebug(f"Received result {self.__state}")

    def __active_cb(self):
        rospy.logdebug(f"Skill {self.__name} execution accepted")
        self.__state = 'CR'
        self.__running = True
        rospy.logdebug(f"Skill {self.__name} running... {self.running}")

    @property
    def running(self):
        return self.__running

    def wait(self, timeout: Optional[float] = 0.0):
        """Wait for completion"""
        rospy.logdebug(f"{self.__name} wait for result")
        return self.__client.wait_for_result(timeout=rospy.Duration.from_sec(timeout))

    ## Result
    @property
    def result(self):
        """Final state"""
        return self.__state

    ## Interruption
    def interrupt(self):
        """Interrupt execution"""
        if self.running:
            self.__client.cancel_goal()
            return True
        else:
            return False
{% endfor %}
